<template>
  <v-container>
    <form @submit.prevent="submit">
      <validation-observer
        ref="observer"
        v-slot="{ invalid }"
      >
        <v-card outlined>
          <v-card-title>Registra tus datos</v-card-title>
          <v-card-text>

            <v-row>
              <v-col
                cols="12"
                sm="12"
                md="6"
              >
                <validation-provider
                  v-slot="{ errors }"
                  name="Nombre"
                  rules="required"
                >
                  <v-text-field
                    outlined
                    v-model="registerForm.name"
                    :error-messages="errors"
                    label="Nombre"
                    required
                  ></v-text-field>
                </validation-provider>
              </v-col>
              <v-col
                cols="12"
                sm="12"
                md="6"
              >

                <validation-provider
                  v-slot="{ errors }"
                  name="Apellido"
                  rules="required"
                >
                  <v-text-field
                    outlined
                    v-model="registerForm.lastname"
                    :error-messages="errors"
                    label="Apellido"
                    required
                  ></v-text-field>
                </validation-provider>
              </v-col>
              <v-col
                cols="6"
                sm="6"
                md="6"
              >
                <validation-provider
                  v-slot="{ errors }"
                  name="Tipo de documento"
                  rules="required"
                >
                  <v-select
                    outlined
                    v-model="registerForm.typeDocument"
                    :items="items"
                    :error-messages="errors"
                    label="Tipo de documento"
                    data-vv-name="select"
                    required
                  ></v-select>
                </validation-provider>
              </v-col>
              <v-col
                cols="6"
                sm="6"
                md="6"
              >
                <validation-provider
                  v-slot="{ errors }"
                  name="Número de documento"
                  :rules="{
                            required: true,
                            regex: getTypeDocumentRegex()
                          }"
                >
                  <v-text-field
                    outlined
                    v-model="registerForm.documentNumber"
                    :error-messages="errors"
                    label="Número de Documento"
                    required
                    v-mask="getTypeDocumentMask()"
                  >
                  </v-text-field>
                </validation-provider>
              </v-col>
              <v-col
                cols="12"
                sm="12"
                md="6"
              >
                <validation-provider
                  v-slot="{ errors }"
                  name="Número de teléfono"
                  :rules="{
                            required: true,
                            digits: 10,
                            regex: /^(?:(?:00)?549?)?0?(?:11|[2368]\d)(?:(?=\d{0,2}15)\d{2})??\d{8}$/
                          }"
                >
                  <v-text-field
                    outlined
                    v-model="registerForm.phoneNumber"
                    :counter="10"
                    :error-messages="errors"
                    label="Número de teléfono"
                    required
                  >
                    <template v-slot:prepend>
                      +54
                    </template>
                  </v-text-field>
                </validation-provider>
              </v-col>
              <v-col
                cols="12"
                sm="12"
                md="6"
              >
                <validation-provider
                  v-slot="{ errors }"
                  name="email"
                  rules="required|email"
                >
                  <v-text-field
                    outlined
                    v-model="registerForm.email"
                    :error-messages="errors"
                    label="E-mail"
                    required
                  >
                  </v-text-field>
                </validation-provider>
              </v-col>
            </v-row>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn @click="clear">
              Limpiar
            </v-btn>
            <v-btn
              class="mr-4"
              type="submit"
              color="primary"
              :disabled="invalid"
            >
              Continuar
            </v-btn>
          </v-card-actions>
        </v-card>
      </validation-observer>
    </form>
  </v-container>
</template>

<script>
import { required, digits, email, max, regex } from 'vee-validate/dist/rules'
import { extend, ValidationObserver, ValidationProvider, setInteractionMode } from 'vee-validate'

setInteractionMode('eager')

extend('digits', {
  ...digits,
  message: '{_field_} tene que contener {length} caracteres. ({_value_})',
})

extend('required', {
  ...required,
  message: 'El {_field_} no puede estar vacio',
})

extend('max', {
  ...max,
  message: '{_field_} no puede superar los {length} caracteres',
})

extend('regex', {
  ...regex,
  message: '{_field_} {_value_} numero invalido',
})

extend('email', {
  ...email,
  message: 'Email invalido',
})

export default {
  components: {
    ValidationProvider,
    ValidationObserver,
  },
  data: () => ({
    registerForm: {
      name: '',
      lastname: '',
      phoneNumber: '',
      email: '',
      typeDocument: null,
      documentNumber: '',
    },
    items: ['DNI', 'CUIL', 'CUIT']
  }),
  created () {
    const registerForm = {
      ...this.$store.getters.getRegisterForm
    }
    if (registerForm.name) {
      this.registerForm = registerForm
    }
  },

  methods: {
    submit () {
      this.$refs.observer.validate()
      this.$store.commit('setRegisterForm', this.registerForm)
      this.$router.push('/check-register')
    },
    clear () {
      this.registerForm.name = ''
      this.registerForm.lastname = ''
      this.registerForm.phoneNumber = ''
      this.registerForm.email = ''
      this.registerForm.documentNumber = ''
      this.registerForm.typeDocument = null
      this.$refs.observer.reset()
    },
    getTypeDocumentRegex () {
      if (this.registerForm.typeDocument === 'DNI') {
        return /^\d{1,2}\.?\d{3}\.?\d{3}$/
      } else {
        return /^\d{2}-\d{8}-\d{1}$/
      }
    },
    getTypeDocumentMask () {
      if (this.registerForm.typeDocument === 'DNI') {
        return '##.###.###'
      } else {
        return '##-########-#'
      }
    }
  },
}
</script>

<style>
</style>